freeslot("MT_ROGERCHAIR", "S_ROGERCHAIR_IDLE", "S_ROGERCHAIR_TRIG", "SPR_CHRS", "SPR_MASH", "S_MASHBUTTONS", "sfx_chair")
states[S_ROGERCHAIR_IDLE] = {SPR_CHRS, A, -1, nil, 0, 0, S_NULL}
states[S_ROGERCHAIR_TRIG] = {SPR_CHRS, B, -1, nil, 0, 0, S_NULL}
states[S_MASHBUTTONS] = {SPR_MASH, A|FF_FULLBRIGHT, 5, nil, 0, 0, S_NULL}
mobjinfo[MT_ROGERCHAIR] = {
	doomednum = 1572,
	spawnstate = S_ROGERCHAIR_IDLE,
	spawnhealth = 1,
	speed = FRACUNIT,
	radius = 30*FRACUNIT,
	height = 40*FRACUNIT,
	dispoffset = 0,
	reactiontime = 0,
	mass = 100,
	damage = 0,
	flags = MF_SCENERY|MF_SPECIAL
}
local function StopSpin(mobj)
	if mobj.speen
		mobj.speen = false
		P_InstaThrust(mobj, mobj.startspeen, -5*FRACUNIT)
		P_SetObjectMomZ(mobj, 5*FRACUNIT)
		mobj.state = S_ROGERCHAIR_IDLE
		mobj.nosoft = TICRATE*3
		if mobj.tracer and mobj.tracer.valid
			if mobj.tracer.player
				mobj.tracer.chairspeed = nil
				mobj.tracer.momx = mobj.momx/3*2
				mobj.tracer.momy = mobj.momy/3*2
				mobj.tracer.momz = mobj.momz/2*3
				mobj.tracer.state = S_PLAY_PAIN
				mobj.tracer = nil
			end
		end
		if S_SoundPlaying(mobj, sfx_chair)
			S_StopSoundByID(mobj, sfx_chair)
		end
	end
end
addHook("TouchSpecial", function(mobj, mo)
	if mobj and mobj.valid
		if mo and mo.valid
		and not mobj.speen
		and not mobj.nosoft
			if mo.type == MT_PLAYER
			and mo.player
			and not mo.chairspeed
				mobj.speen = true
				mobj.tracer = mo
				mobj.startspeen = R_PointToAngle2(0, 0, mo.momx, mo.momy)
				mobj.angle = mobj.startspeen
				mo.chairspeed = mobj
				mo.state = S_PLAY_PAIN
				mobj.speeding =  mo.player.speed + ((mobj.startspeedangle/ANG1*FRACUNIT)*2)
				mobj.friction = FRACUNIT
				P_InstaThrust(mobj, mobj.startspeen, mobj.speeding)
				if mobj.speeding and mobj.speeding >= FRACUNIT*30
					mobj.state = S_ROGERCHAIR_TRIG
				end
				mobj.startmomx = mobj.momx
				mobj.startmomy = mobj.momy
			end
		end
		return true
	end
end, MT_ROGERCHAIR)
addHook("MobjThinker", function(mo)
	if mo and mo.valid
		mo.nosoft = $ or 0
		if mo.nosoft
			mo.nosoft = $ - 1
		end
		if mo.speen and mo.type == MT_ROGERCHAIR
			mo.angle = $ - mo.speeding/FRACUNIT*ANG1
			mo.friction = FRACUNIT
			if not S_SoundPlaying(mo, sfx_chair)
				S_StartSound(mo, sfx_chair)
			end
			if (mo.momx != mo.startmomx
			or mo.momy != mo.startmomy)
			or (mo.momx == 0 or mo.momy == 0)
				StopSpin(mo)
			end
			if mo.tracer and mo.tracer.valid
			and mo.tracer.player
				mo.tracer.player.drawangle = mo.angle
				//mo.tracer.state = S_PLAY_PAIN
			end
		end
		if mo.chairspeed and mo.type == MT_PLAYER
			if mo.chairspeed and mo.chairspeed.valid
				local addx = FixedMul(FRACUNIT,cos(mo.chairspeed.angle))
				local addy = FixedMul(FRACUNIT,sin(mo.chairspeed.angle))
				P_TeleportMove(mo, mo.chairspeed.x+addx, mo.chairspeed.y+addy, mo.chairspeed.z+(mo.chairspeed.height/3*2)+20*FRACUNIT)
				mo.momx = mo.chairspeed.momx
				mo.momy = mo.chairspeed.momy
				mo.momz = mo.chairspeed.momz
				if mo.player
					local player = mo.player
					player.pflags = $ & ~PF_SPINNING
					if player.timermash
						player.timermash = $ - 1
						if player.timermash >= 18
							player.mo.state = S_PLAY_JUMP
							if player.timermash >= 19
								mo.spriteyoffset = P_RandomRange(-3, 3)*FRACUNIT
								mo.spritexoffset = P_RandomRange(-3, 3)*FRACUNIT
							else	
								mo.spriteyoffset = 0
								mo.spritexoffset = 0
							end	
							player.mashing = true
						else
							player.mo.state = S_PLAY_PAIN
							if player.mashing
								player.mashing = false
								mo.spriteyoffset = 0
								mo.spritexoffset = 0
								player.mo.state = S_PLAY_PAIN
							end
						end
						player.stopmash = true
					else
						player.mo.state = S_PLAY_PAIN
						if player.stopmash
							player.stopmash = false
							player.mashout = 0
						end
					end	
					if player.cmd.buttons & BT_JUMP
						if not player.jmp
							if not player.mashout
								player.mashout = 1
							else
								player.mashout = $ + 1
							end
							player.mo.state = S_PLAY_JUMP
							mo.spriteyoffset = P_RandomRange(-3, 3)*FRACUNIT
							mo.spritexoffset = P_RandomRange(-3, 3)*FRACUNIT
							player.timermash = 13
							S_StartSound(mo, sfx_jump)
							P_SetObjectMomZ(mo.chairspeed, 3*FRACUNIT)
							local mash = P_SpawnMobjFromMobj(player.mo, 0, 0, mo.height, MT_THOK)
							mash.tics = TICRATE
							mash.fuse = 5
							mash.state = S_MASHBUTTONS
							mash.scale = FRACUNIT*2
							mash.rollangle = $ + P_RandomRange(-135, 135)*ANG1
						end
						player.jmp = true
					else
						player.jmp = false
					end
					if player.mashout and player.mashout >= 6
						player.mashout = 0
						player.timermash = 0
						player.stopmash = false
						P_DoJump(player)
						P_SetObjectMomZ(mo, 8*FRACUNIT)
						mo.spriteyoffset = 0
						mo.spritexoffset = 0
						if mo.chairspeed.speen
							//mo.chairspeed.speen = false
							//P_Thrust(mo.chairspeed, mo.chairspeed.startspeen, -FRACUNIT)
							P_SetObjectMomZ(mo.chairspeed, -FRACUNIT)
							P_Thrust(mo, mo.chairspeed.angle, 5*FRACUNIT)
							P_Thrust(mo.chairspeed, mo.chairspeed.angle, -FRACUNIT*5)
							mo.chairspeed.startmomx = mo.chairspeed.momx
							mo.chairspeed.startmomy = mo.chairspeed.momy
							//mo.chairspeed.state = S_ROGERCHAIR_IDLE
							mo.chairspeed.nosoft = TICRATE*2
							mo.chairspeed.tracer = nil
							mo.chairspeed = nil
							mo.spriteyoffset = 0
							mo.spritexoffset = 0
						end
					end
				end
			end	
		end
	end
end)



local function ch_createrogerchair(player)
	if player.valid
		local addx = FixedMul(150*FRACUNIT, cos(player.mo.angle))
		local addy = FixedMul(150*FRACUNIT, sin(player.mo.angle))
		local chair = P_SpawnMobjFromMobj(player.mo, addx, addy, 50*FRACUNIT, MT_ROGERCHAIR)
	end
end

COM_AddCommand("ch_createrogerchair", ch_createrogerchair)
addHook("MobjSpawn", function(mo) //Leave this be
	if mo and mo.valid
		mo.startspeedangle = mo.angle
	end
end, MT_ROGERCHAIR)